{% import "./macros.j2" as macros %}

<link rel="stylesheet" href="/static/main.css"/>

<style>

 table.wide tbody tr.alarm td {
     background: #f004;
 }

 table.wide tbody tr.broken td {
     background: #999;
     color: black;
 }

 .filtered {
     background: yellow;
 }

 label {
     padding-right: 10px;
 }


 input[type=radio].sort {
     display: none;
 }

 input[type=checkbox].sort {
     display: none;
 }

</style>

<header>
    <title>
        ArchWizard 🧙
    </title>
</header>

<body>

    <div class="info">

        <h2>
            HDB Configuration Manager: {{ hdbpp.manager_device }}
        </h2>

        <h3>Status</h3>
        <div class="status">{{attributes.Status}}</div>

        <table class="status">
            <tr>
                <td>
                    <li># attributes: {{ attributes.AttributeNumber }}</li>
                    <li># NOK attributes: {{ attributes.AttributeNokNumber }}</li>
                    <li># stopped attributes: {{ attributes.AttributeStoppedNumber }}</li>
                    <li># pending attributes: {{ attributes.AttributePendingNumber }}</li>
                </td>
                <td>
                    <li>Recording frequency:
                        {{ "%.1f"|format(attributes.AttributeRecordFreq) }} / minute</li>
                    <li>Failure frequency:
                        {{ "%.1f"|format(attributes.AttributeFailureFreq) }} / minute</li>
                </td>
                <td>
                    <li>Max store time:
                        {{ "%.3f"|format(attributes.AttributeMaxStoreTime) }} s</li>
                    <li>Min store time:
                        {{ "%.3f"|format(attributes.AttributeMinStoreTime) }} s</li>
                    <li>Max processing time:
                        {{ "%.3f"|format(attributes.AttributeMaxProcessingTime) }} s</li>
                    <li>Min processing time:
                        {{ "%.3f"|format(attributes.AttributeMinProcessingTime) }} s</li>
                </td>
            </tr>
        </table>

        <h3 title="Search for archived attributes, by substring">Attribute search</h3>
        <form name="attribute-search">
            <input type="search" name="attr_search" value="{{ attr_search or '' }}"
                   placeholder="Device/attribute...">
            <button name="submit" type="submit">Submit</button>
            <button name="clear" value="true">Clear</button>
        </form>

    </div>

    {% if search_results %}
        <table class="wide sortable">
            <thead>
                <tr>
                    <th>Attribute</th>
                    <th>Archiver</th>
                </tr>
            </thead>

            <tbody>
                {% for attribute in search_results %}
                    <tr>
                        <td>
                            <a href="{{ url_for('show_attribute', manager=manager) }}?attribute={{ attribute | quote_plus }}">
                                {{ attribute | shorten_attribute_name }}
                            </a>
                        </td>
                        <td>
                            <a href="{{ url_for('show_archiver', manager=manager) }}?attribute={{ attribute | shorten_attribute_name }}&filter={{ attribute | shorten_attribute_name }}">
                                Link
                            </a>
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    {% endif %}

    <form method="get" action="{{ url_for('show_manager', manager=manager) }}">
        <div class="info">
            <h3>Archivers</h3>

            <div class="filters">
                <input class="filter{% if filter %} filtered{% endif %}"
                       placeholder="Filter archivers"
                       name="filter" value="{{ filter or '' }}"/>

                {{ macros.filter_only("alarm", only) }}
                {{ macros.filter_only("fault", only) }}
                {{ macros.filter_only("nok", only) }}
                {{ macros.filter_only("pending", only) }}

                <button type="submit">
                    Apply
                </button>

                <button name="clear" value="true">
                    Clear
                </button>
            </div>
        </div>

        <table id="archivers" class="wide sortable">

            <thead>
                <tr>
                    <th title="Device name of the archiver"> {{ macros.sort_header("name", sort, sort_rev) }} </th>
                    <th title="Tango state of the archiver device"> {{ macros.sort_header("state", sort, sort_rev) }} </th>
                    <th title="Total number of attributes handled by the archiver"> {{ macros.sort_header("total", sort, sort_rev) }} </th>
                    <th title="Number of attributes currently reporting errors, preventing them from being archived."> {{ macros.sort_header("nok", sort, sort_rev) }} </th>
                    <th title="Number of events currently in queue for storage."> {{ macros.sort_header("pending", sort, sort_rev) }} </th>
                    <th title="Error message, if any">Error</th>
                </tr>
            </thead>

            <tbody>
                {% for archiver in archivers %}
                    <tr class="{% if archiver.alarm %}alarm{% endif %}
                               {% if archiver.broken %}broken{% endif %}" >
                        <td>
                            <a href="{{ url_for("show_archiver", manager=manager) }}?archiver={{ archiver.name | shorten_archiver_name | quote_plus }}"> {{ archiver.name }} </a>
                        </td>
                        <td>{{ archiver.state or ""}}</td>
                        <td>{{ archiver.total or ""}}</td>
                        <td>{{ archiver.nok or ""}}</td>
                        <td>{{ archiver.pending or ""}}</td>
                        <td>{{ archiver.error or ""}}</td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </form>

</body>

<footer>
    <p>Rendered at {{ now }}</p>
</footer>
